<template>
  <div class="q-pa-md">
    
    <q-table
      title="Object"
      :data="objects"
      row-key="id"
      :columns="columns"
      selection="multiple"
      :selected.sync="selected"
    >
      <template v-slot:body-cell-model="objects">
        <q-td :objects="objects" align="left" width="300">
          
          <model-obj
            :width="400"
            :src='objects.row.obj'
            :mtl='objects.row.mtl'
            :backgroundColor="hex"
            :rotation="rotation"
            >
          </model-obj>
          <!-- <img src="~/assets/a.png" alt="" width="400px"> -->
        </q-td>
      </template>
      <template v-slot:body-cell-action="objects">
        <q-td :objects="objects" align="left" width="20px">
          <q-btn
            color="primary"
            icon="edit"
            @click="ShowEditModal(objects.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          <q-btn
            color="red"
            icon="delete"
            @click="ShowDeleteModal(objects.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      <template v-slot:top>
        <q-btn
          color="primary"
          label="Add Object"
          @click="ShowAddModal()"
        />
        <q-btn
          v-if="selected.length"
          class="q-ml-sm"
          color="red"
          label="Delete Object"
          @click="ShowMoreDeleteModal()"
        />
        <q-space />
        <q-input
          dense
          rounded
          v-on:keyup="filterFn"
          standout="bg-info text-white"
          v-model="search_text"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="search_text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="filter"
            />
          </template>
        </q-input>
      </template>
    </q-table>
    <!-- Add Model -->
    <q-dialog v-model="AddModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendAddData"
        @keyup.esc="AddModalCancel()"
      >
        <q-card-section>
          <div class="text-h6">New Object</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input dense v-model="AddData.name" autofocus />
        </q-card-section>
       
        <q-card-section class="q-pt-none">
           <q-file
            class="q-ma-xs q-mb-md col-12"
            multiple
            append
            dense
            @input="link(files)"
            label="Files"
            use-chips
            hint="Click to select files to link"
            bottom-slots
            v-model="files"
            counter>

            </q-file>
        </q-card-section>
       
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Create" @click="SendAddData" />
          <q-btn flat label="Cancel" @click="AddModalCancel()" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Add Model -->
    <!-- Edit Model -->
    <q-dialog v-model="EditModal" persistent>
       <q-card
        style="min-width: 350px;"
        @keyup.enter="SendEditData"
        @keyup.esc="EditModalCancel()"
      >
        <q-card-section>
          <div class="text-h6">Updata Object</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input dense v-model="EditData.name" autofocus />
        </q-card-section>
       <q-card-section class="q-pt-none">
         <q-chip  v-for="file in EditData.model" :key="file.id" removable    @remove="filedelete(file.id)" color="primary" text-color="white" icon="folder">
           {{file.id}}
        </q-chip>
       </q-card-section>
        <q-card-section class="q-pt-none">
           <q-file
            class="q-ma-xs q-mb-md col-12"
            multiple
            append
            dense
            @input="link(Editfiles)"
            label="Files"
            use-chips
            hint="Click to select files to link"
            bottom-slots
            v-model="Editfiles"
            counter>

            </q-file>
        </q-card-section>
       
        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Update" @click="SendEditData" />
          <q-btn flat label="Cancel" @click="EditModalCancel()" />
        </q-card-actions>
      </q-card>
      
    </q-dialog>
    <!-- End Edit Model -->
    <!-- Delete Dialog -->
    <q-dialog v-model="DeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendDeleteData"
        @keyup.esc="DeleteModal = false"
      >
        <q-card-section>
          <div class="text-h6">Delete Object</div>
        </q-card-section>

        <q-card-section>
          <div class="text-h7">You agree to delete this information?</div>
        </q-card-section>
        <q-card-section>
          <div class="text-h7">
            Name:{{ DeleteData.name }}
            <br />
          </div>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="negative" label="Delete" @click="SendDeleteData" />
          <q-btn flat label="Cancel" @click="DeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Delete Dialog -->
    <!-- Start Multi Delete Modal  -->
    <q-dialog v-model="multiDeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="selected.id"
        @keyup.esc="multiDeleteModal = false"
      >
        <q-card-section class="bg-deep-orange text-white">
          <div class="text-h6">Are you sure delete this objects ?</div>
        </q-card-section>
        <q-form id="validates">
          <q-card-section class="q-pt-md">
            <div v-for="(selects, i) in selected" :key="i">
              <div class="row">
                <div class="row">
                  <p class="text-weight-bold q-pr-sm">{{ i + 1 }}. Name :</p>
                  {{ selects.name }}
                </div>
              </div>
            </div>
          </q-card-section>
        </q-form>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="red" label="Delete" @click="sendmultiDelete" />
          <q-btn flat label="Cancel" @click="multiDeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Multi Delete Modal  -->
  </div>
</template>

<script>
import axios from 'axios'
import { Notify } from 'quasar'
import {  ModelObj } from 'vue-3d-model'
export default {
  name: 'PageIndex',
  components: {
    ModelObj,
  },
  data() {
    return {
      hex: '#ffffff',
      rotation: {
        x: Math.PI/9,
        y: -Math.PI/9,
        z: 0
      },
      search_text: '',
      objects: [],
      allobjects: [],
      selected: [],
      columns: [
        {
          name: 'index',
          label: '#',
          field: 'index',
          align: 'left',
          style: 'width: 10px',
          sortable: true,
        },
        {
          name: 'name',
          field: 'name',
          label: 'Object Name',
          align: 'left',
          sortable: true,
        },
        {
          name: 'model',
          field: 'model',
          label: 'Model',
          align: 'left',
          sortable: false,
        },
        {
          name: 'action',
          label: 'Action',
          align: 'left',
          style: 'width: 20px !important',
        },
      ],
      AddModal: false,
      AddData: {
        name: '',
      },
      files:[]  ,
      Editfiles:[]  ,
      EditModal: false,
      EditData: [],
      DeleteModal: false,
      DeleteData: [],
      multiDeleteModal: false,
    }
  },
  async mounted() {
    this.getobject()
  },

  methods: {
    filedelete(id){
      let data = {
        id
      }
      this.$axios({
          method: 'post',
          url: 'http://127.0.0.1:10/api/objects/filedelete',
          data: data,
        })
        .then((r)=>{
          this.EditData.model=this.EditData.model.filter(v=>v.id!=id)

        })
    },
    link (file) {
      console.log(this.Editfiles);
    },
    async getobject() {
      await axios
        .get('http://127.0.0.1:10/api/objects/')
        .then((response) => {
          var data = response.data
          //console.log(response.data.data)
          var j = []
          for (var i = 0; i < data.length; i++) {
            let getfiles= data[i].file
            let obj=""
            let mtl=""
            for(let h=0;h<getfiles.length;h++){
              let type= getfiles[h].url.split(".")[getfiles[h].url.split(".").length-1]
              if(type=="obj"){
                obj="http://127.0.0.1:10/storage/"+getfiles[h].url
              }
              if(type=="mtl"){
                mtl="http://127.0.0.1:10/storage/"+getfiles[h].url
              }
            }
            var json = {
              index: i+1,
              id: data[i].id,
              name: data[i].name,
              model:data[i].file,
              obj: obj,
              mtl:mtl
            }
            j.push(json)
          }
          this.objects = j
          this.allobjects = j
         
        })
        .catch((e) => {
          var res = e.response
          if (res.status == 401) {
            this.auth()
          } else {
            Notify.create({
              type: 'negative',
              message: 'Something Error',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
          }
        })
    },
    
    ShowAddModal() {
      this.AddModal = true
    },

    AddModalCancel() {
      this.AddData = {
        id: '',
        name: '',
      }
      this.AddModal = false
      this.files=[]
    },

    async SendAddData() {

      if (this.AddData.name.length < 3) {
        Notify.create({
              type: 'negative',
              message: 'The name must be at least 3 characters.',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
      if (this.files.length < 1) {
        Notify.create({
              type: 'negative',
              message: 'The Files not .',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
      this.$q.loading.show()
      
     
      await this.$axios({
          method: 'post',
          url: 'http://127.0.0.1:10/api/objects/create',
          data: this.AddData,
        })
        .then((res) => {
          let create_id=res.data.id;

          for (let i = 0; i < this.files.length; i++) {
            let formData = new FormData()
            formData.append('file', this.files[i])
            formData.append('id',create_id)
              this.$axios({
                  method: 'post',
                  url: 'http://127.0.0.1:10/api/objects/upload',
                  data: formData,
                  headers: {
                    'Content-Type': 'multipart/form-data'
                  }
              })
              .then((re) => {
          this.getobject()

                 Notify.create({
                    type: 'positive',
                    message: 'Succesfully Create Object Data',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
              })
              .catch((e) => {
                var data={
                  id:create_id
                }
                this.$axios({
                  method: 'post',
                  url: 'http://127.0.0.1:10/api/objects/deleteObject',
                  data: data,
                })
                
                  Notify.create({
                    type: 'negative',
                    message: 'Something Error',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
                
              })
          }
          this.AddModal = false
          this.AddData = {
            id: '',
            name: '',
          }
          this.files=[]
        })
        .catch((e) => {
          var res = e.response
          Notify.create({
              type: 'negative',
              message: 'Something Error',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        })
      
      this.getobject()
      this.$q.loading.hide()
    },
    async SendEditData() {
       if (this.EditData.name.length < 3) {
        Notify.create({
              type: 'negative',
              message: 'The name must be at least 3 characters.',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
      
      this.$q.loading.show()
        this.$axios({
          method: 'post',
          url: 'http://127.0.0.1:10/api/objects/update_object',
          data: this.EditData,
        })
        .then((res) => {
          let create_id= this.EditData.id
      for (let i = 0; i < this.Editfiles.length; i++) {
            console.log(i);
            let formEditdata = new FormData()
            formEditdata.append('file', this.Editfiles[i])
            formEditdata.append('id',create_id)
            console.log(formEditdata);
              this.$axios({
                  method: 'post',
                  url: 'http://127.0.0.1:10/api/objects/upload',
                  data: formEditdata,
                  headers: {
                    'Content-Type': 'multipart/form-data'
                  }
              })
              .then((re) => {
                  Notify.create({
                    type: 'positive',
                    message: 'Succesfully Create Object Data',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })

              })
              .catch((e) => {
                Notify.create({
                    type: 'negative',
                    message: 'Something Error',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
              })
          }
          this.EditModal=false
          this.Editfiles=[]
          this.getobject()


        })
        .catch((e) => {
            Notify.create({
              type: 'negative',
              message: 'Something Error',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        })
        this.$q.loading.hide()
  
    },
    ShowEditModal(data) {
      this.EditModal = true
      this.EditData = {
        id: data.id,
        name: data.name,
        model: data.model,
      }
      console.log(this.EditData.model[0].id);
    },
    EditModalCancel() {
      this.EditData = []
      this.EditModal = false
      this.Editfiles=[]
    },
    ShowDeleteModal(row) {
      this.DeleteData = row
      this.DeleteModal = true
    },
    async SendDeleteData() {
      this.$q.loading.show()
      var da = {
        id: this.DeleteData.id,
      }
      await axios
        .post(this.$domen+'objects/deleteObject', da)
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 200) {
            Notify.create({
                    type: 'positive',
                    message: 'Succesfully Create Object Data',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
            this.DeleteModal = false
          }
        })
        .catch((e) => {
           Notify.create({
            type: 'negative',
            message: 'Something Error',
            position: "bottom-right",
            progress: true,
            actions: [
                { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
            ]
        })
        })
      this.getobject()
      this.$q.loading.hide()
    },
    ShowMoreDeleteModal() {
      this.multiDeleteModal = true
    },
    async sendmultiDelete() {
      this.$q.loading.show()
      let sender = JSON.stringify(this.selected)
      await axios
        .post(this.$domen+'objects/multidelete', {
          data: sender,
        })
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 200) {
                Notify.create({
                    type: 'positive',
                    message: 'Succesfully Create Object Data',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
            this.multiDeleteModal = false
          }
        })
        .catch((e) => {
          var res = e.response
          if (res.status == 401) {
            this.auth()
          } else {
            Notify.create({
                type: 'negative',
                message: 'Something Error',
                position: "bottom-right",
                progress: true,
                actions: [
                    { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                ]
            })
          }
        })
      this.getobject()
      this.selected=[]
      this.$q.loading.hide()
    },
    filterFn(){
      console.log(this.allcategorys);
     
        this.objects=this.allobjects.filter(v=>v.name.toLowerCase().indexOf(this.search_text.toLowerCase()) > -1)
    },
    filter(){
      this.objects=this.allobjects
      this.search_text=''
    }
    
  },
}
</script>
